#ifndef LIB_LCD
#define LIB_LCD

#define LCD_DATA      PORTA       
#define LCD_DATA_DR   DDRA

#define LCD_CONF      PORTB       
#define LCD_CONF_DR   DDRB

#define LCD_EN        0
#define LCD_RW        1
#define LCD_RS        2

#define LCD_BOOTUP_MS           15
#define LCD_ENABLE_US           1
#define LCD_WRITEDATA_US        46
#define LCD_COMMAND_US          42

#define LCD_SOFT_RESET_MS1      5
#define LCD_SOFT_RESET_MS2      1
#define LCD_SOFT_RESET_MS3      1
#define LCD_SET_4BITMODE_MS     5
#define LCD_CLEAR_DISPLAY_MS    2
#define LCD_CURSOR_HOME_MS      2

#define LCD_CURSOR_HOME         0x02
#define LCD_SET_DDADR           0x80


#define LCD_SET_FUNCTION        0x20
#define LCD_FUNCTION_4BIT       0x00
#define LCD_FUNCTION_8BIT       0x10
#define LCD_FUNCTION_1LINE      0x00
#define LCD_FUNCTION_2LINE      0x08
#define LCD_FUNCTION_5X7        0x00
#define LCD_FUNCTION_5X10       0x04
#define LCD_SOFT_RESET          0x30

#define LCD_CLEAR_DISPLAY       0x01
#define LCD_SET_FUNCTION        0x20
#define LCD_SET_DISPLAY         0x08
#define LCD_DISPLAY_OFF         0x00
#define LCD_DISPLAY_ON          0x04
#define LCD_CURSOR_OFF          0x00
#define LCD_CURSOR_ON           0x02
#define LCD_BLINKING_OFF        0x00
#define LCD_BLINKING_ON         0x01
#define LCD_SET_ENTRY           0x04

#define LCD_ENTRY_DECREASE      0x00
#define LCD_ENTRY_INCREASE      0x02
#define LCD_ENTRY_NOSHIFT       0x00
#define LCD_ENTRY_SHIFT         0x01

#define LCD_DDADR_LINE1         0x00
#define LCD_DDADR_LINE2         0x40
#define LCD_DDADR_LINE3         0x10
#define LCD_DDADR_LINE4         0x50


void lcd_enable(void);
void lcd_out(uint8_t data);
void lcd_command(uint8_t data);
void lcd_clear(void);
void lcd_init(void);
void lcd_home(void);
void lcd_setcursor( uint8_t x, uint8_t y );
void lcd_data(uint8_t data);
void lcd_string( const char *data );
void lcd_string_xy( uint8_t x, uint8_t y, const char *data );


#endif
